Index: trunk/XTIDE_Universal_BIOS/makefile
===================================================================
--- trunk/XTIDE_Universal_BIOS/makefile	(revision 370)
+++ trunk/XTIDE_Universal_BIOS/makefile	(revision 379)
@@ -1,17 +1,34 @@
-###############################################################################
-# Makefile to build XTIDE Universal BIOS.                                     #
-#                                                                             #
-# Valid makefile targets are:                                                 #
-# all		Removes existing files and builds binary files in \Build          #
-# small		Builds 8 kiB binaries only (without checksum)                     #
-# large		Builds 15 kiB binaries only (without checksum)                    #
-# clean		Removes all files from \Build                                     #
-# checksum*	Builds all and then generates checksum byte to all binary files   #
-# strings*	Compress src\strings.asm to src\StringsCompressed.asm             #
-#                                                                             #
-# * at the end of target name means that Perl is required for the job.        #
-# Build directory must be created manually if it does not exist.              #
-#                                                                             #
-###############################################################################
+##################################################################################################
+# Makefile to build XTIDE Universal BIOS.                                                        #
+#                                                                                                #
+# Valid makefile targets are:                                                                    #
+# all		Removes existing files and builds binary files in \Build                             #
+# small		Builds 8 kiB binaries only (without checksum)                                        #
+# large		Builds 15 kiB binaries only (without checksum)                                       #
+# clean		Removes all files from \Build                                                        #
+# checksum*	Builds all and then generates checksum byte to all binary files                      #
+# strings*	Compress src\strings.asm to src\StringsCompressed.asm                                #
+#                                                                                                #
+# * at the end of target name means that Perl is required for the job.                           #
+# Build directory must be created manually if it does not exist.                                 #
+#                                                                                                #
+#                                                                                                #
+# Following modules can be included or excluded:                                                 #
+# MODULE_ADVANCED_ATA       Native support for some VLB IDE controllers                          #
+# MODULE_BOOT_MENU          Boot Menu for selection drive to boot from                           #
+# MODULE_EBIOS              Enhanced functions for access drives over 8.4 GB                     #
+# MODULE_JRIDE              Support for JR-IDE/ISA                                               #
+# MODULE_SERIAL             Virtual hard disks using serial port                                 #
+# MODULE_SERIAL_FLOPPY      Virtual floppy drives using serial port                              #
+# MODULE_STRINGS_COMPRESSED Compressed strings to save space                                     #
+#                                                                                                #
+# Not modules but these affect the assembly:                                                     #
+# ELIMINATE_CGA_SNOW        Prevents CGA snowing at the cost of few bytes                        #
+# USE_186                   Use instructions supported by 80188/80186 and V20/V30 and later      #
+# USE_286                   Use instructions supported by 286 and later                          #
+# USE_386                   Use instructions supported by 386 and later                          #
+# USE_AT                    Use features supported on AT and later systems (not available on XT) #
+#                                                                                                #
+##################################################################################################
 
 ###########################################
@@ -69,5 +86,5 @@
 # Assembler preprocessor defines.                               #
 #################################################################
-DEFINES = INCLUDE_MENU_LIBRARY EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS MODULE_EBIOS MODULE_STRINGS_COMPRESSED
+DEFINES = MODULE_BOOT_MENU MODULE_EBIOS MODULE_STRINGS_COMPRESSED
 DEFINES_XT = ELIMINATE_CGA_SNOW MODULE_SERIAL MODULE_SERIAL_FLOPPY
 DEFINES_XTPLUS = ELIMINATE_CGA_SNOW USE_186 MODULE_SERIAL MODULE_SERIAL_FLOPPY
@@ -128,5 +145,5 @@
 ASFLAGS += $(IHEADERS)			# Set header file directory paths
 ASFLAGS += -Worphan-labels		# Warn about labels without colon
-ASFLAGS += -O9					# Optimize operands to their shortest forms
+ASFLAGS += -Ox					# Optimize operands to their shortest forms
 
 