Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/BootMenuSettingsMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/BootMenuSettingsMenu.asm	(revision 380)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/BootMenuSettingsMenu.asm	(revision 399)
@@ -3,5 +3,5 @@
 
 ;
-; XTIDE Universal BIOS and Associated Tools 
+; XTIDE Universal BIOS and Associated Tools
 ; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
 ;
@@ -10,11 +10,11 @@
 ; the Free Software Foundation; either version 2 of the License, or
 ; (at your option) any later version.
-; 
+;
 ; This program is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-; GNU General Public License for more details.		
+; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
-;		
+;
 
 ; Section containing initialized data
@@ -71,5 +71,5 @@
 iend
 
-g_MenuitemBootMenuSerialScanDetect:		
+g_MenuitemBootMenuSerialScanDetect:
 istruc MENUITEM
 	at	MENUITEM.fnActivate,		dw	Menuitem_ActivateMultichoiceSelectionForMenuitemInDSSI
@@ -134,4 +134,5 @@
 iend
 
+%if 0	; *FIXME*
 g_MenuitemBootMnuStngsSwapBootDriveNumbers:
 istruc MENUITEM
@@ -149,4 +150,5 @@
 	at	MENUITEM.itemValue + ITEM_VALUE.wValueBitmask,				dw	FLG_ROMVARS_DRVXLAT
 iend
+%endif
 
 
@@ -221,5 +223,5 @@
 	or		[g_MenuitemBootMnuStngsDefaultBootDrive+MENUITEM.bFlags], al
 	or		[g_MenuitemBootMnuStngsSelectionTimeout+MENUITEM.bFlags], al
-	or		[g_MenuitemBootMnuStngsSwapBootDriveNumbers+MENUITEM.bFlags], al
+;	or		[g_MenuitemBootMnuStngsSwapBootDriveNumbers+MENUITEM.bFlags], al
 	ret
 
@@ -228,6 +230,6 @@
 	and		[g_MenuitemBootMnuStngsDefaultBootDrive+MENUITEM.bFlags], al
 	and		[g_MenuitemBootMnuStngsSelectionTimeout+MENUITEM.bFlags], al
-	and		[g_MenuitemBootMnuStngsSwapBootDriveNumbers+MENUITEM.bFlags], al
-	ret	
+;	and		[g_MenuitemBootMnuStngsSwapBootDriveNumbers+MENUITEM.bFlags], al
+	ret
 
 
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/IdeControllerMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/IdeControllerMenu.asm	(revision 380)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/IdeControllerMenu.asm	(revision 399)
@@ -3,5 +3,5 @@
 
 ;
-; XTIDE Universal BIOS and Associated Tools 
+; XTIDE Universal BIOS and Associated Tools
 ; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
 ;
@@ -10,11 +10,11 @@
 ; the Free Software Foundation; either version 2 of the License, or
 ; (at your option) any later version.
-; 
+;
 ; This program is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-; GNU General Public License for more details.		
+; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
-;		
+;
 
 ; Section containing initialized data
@@ -523,6 +523,6 @@
 		jb		.writeNonSerial
 
-		mov		ax,DEVICE_ATA_DEFAULT_PORT			; Defaults for 16-bit and better ATA devices
-		mov		bx,DEVICE_ATA_DEFAULT_PORTCTRL
+		mov		ax, DEVICE_ATA_PRIMARY_PORT			; Defaults for 16-bit and better ATA devices
+		mov		bx, DEVICE_ATA_PRIMARY_PORTCTRL
 
 .writeNonSerial:
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 380)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 399)
@@ -356,5 +356,5 @@
 g_szItemBootDispMode:	db	"Display Mode",NULL
 g_szItemBootFloppyDrvs:	db	"Number of Floppy Drives",NULL
-g_szItemBootSwap:		db	"Swap boot drive numbers",NULL
+;g_szItemBootSwap:		db	"Swap boot drive numbers",NULL
 g_szItemSerialDetect:	db	"Scan for Serial Drives",NULL
 
@@ -364,5 +364,5 @@
 g_szDlgBootDispMode:	db	"Select display mode for Boot Menu.",NULL
 g_szDlgBootFloppyDrvs:	db	"Select number of Floppy Drives to display on boot menu.",NULL
-g_szDlgBootSwap:		db	"Enable drive number translation?",NULL
+;g_szDlgBootSwap:		db	"Enable drive number translation?",NULL
 g_szDlgSerialDetect:	db	"Scan for serial drives?",NULL
 
@@ -372,5 +372,5 @@
 g_szNfoDispMode:		db	"Display Mode for Boot Menu.",NULL
 g_szNfoBootFloppyDrvs:	db	"Number of Floppy Drives to display on boot menu.",NULL
-g_szNfoBootSwap:		db	"Drive Number Translation (swap first drive with selected).",NULL
+;g_szNfoBootSwap:		db	"Drive Number Translation (swap first drive with selected).",NULL
 g_szNfoSerialDetect:	db	"Scans all standard COM ports for serial drives."
 						db	" This can also be invoked by holding down ALT at the end of normal drive detection.",NULL
@@ -382,6 +382,6 @@
 g_szHelpBootFloppyDrvs:	incbin	"Bootmenu_FloppyDrives.txt"
 						db	NULL
-g_szHelpBootSwap:		incbin	"Bootmenu_SwapDrives.txt"
-						db	NULL
+;g_szHelpBootSwap:		incbin	"Bootmenu_SwapDrives.txt"
+;						db	NULL
 g_szHelpSerialDetect:	incbin  "Bootmenu_SerialDetect.txt"
 						db  NULL